// TestUseEPCSDKDlg.cpp : implementation file
//

#include "stdafx.h"
#include "TestUseEPCSDK.h"
#include "TestUseEPCSDKDlg.h"
#include "EPCSDK.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestUseEPCSDKDlg dialog

CTestUseEPCSDKDlg::CTestUseEPCSDKDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTestUseEPCSDKDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTestUseEPCSDKDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_handle = INVALID_HANDLE_VALUE;
}

void CTestUseEPCSDKDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTestUseEPCSDKDlg)
	DDX_Control(pDX, IDC_OperationList, m_editList);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTestUseEPCSDKDlg, CDialog)
	//{{AFX_MSG_MAP(CTestUseEPCSDKDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_Open, OnOpen)
	ON_BN_CLICKED(IDC_Close, OnClose)
	ON_BN_CLICKED(IDC_ReadFirmVersion, OnReadFirmVersion)
	ON_BN_CLICKED(IDC_ResumeReadingTag, OnResumeReadingTag)
	ON_BN_CLICKED(IDC_StopReadingTag, OnStopReadingTag)
	ON_BN_CLICKED(IDC_StartReadingMultiTags, OnStartReadingMultiTags)
	ON_BN_CLICKED(IDC_StartReadingSingleTag, OnStartReadingSingleTag)
	ON_BN_CLICKED(IDC_StopReadingMultiTags, OnStopReadingMultiTags)
	ON_BN_CLICKED(IDC_StopReadingSingleTag, OnStopReadingSingleTag)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_Clear, OnClear)
	ON_BN_CLICKED(IDC_FastWriteTag, OnFastWriteTag)
	ON_BN_CLICKED(IDC_Initialize, OnInitializeTag)
	ON_BN_CLICKED(IDC_Lock, OnLockTag)
	ON_BN_CLICKED(IDC_Destroy, OnDestroyTag)
	ON_BN_CLICKED(IDC_WriteTagSingleWord, OnWriteTagSingleWord)
	ON_BN_CLICKED(IDC_ReadTagContent, OnReadTagContent)
	ON_BN_CLICKED(IDC_GetParams, OnGetParams)
	ON_BN_CLICKED(IDC_SetParams, OnSetParams)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestUseEPCSDKDlg message handlers

BOOL CTestUseEPCSDKDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);


	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
		CenterWindow(GetDesktopWindow());	// center to the hpc screen
	// TODO: Add extra initialization here

	int iFullWidth = GetSystemMetrics(SM_CXSCREEN); 
	int iFullHeight = GetSystemMetrics(SM_CYSCREEN); 

	//LONG un=GetDialogBaseUnits();
	
	CWnd *pTaskbar = CWnd::FindWindow(_T("HHTaskBar"), NULL);
	CRect rc;
	if(pTaskbar){
		pTaskbar->GetWindowRect(rc);
		int nWidth = rc.Width();
		int nHeight = rc.Height(); 
			iFullHeight-=nHeight;
	}



	::SetWindowPos(this->m_hWnd, HWND_TOPMOST, 0, 0, iFullWidth, 
		iFullHeight, SWP_NOOWNERZORDER|SWP_SHOWWINDOW);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTestUseEPCSDKDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTestUseEPCSDKDlg::OnPaint() 
{
		CDialog::OnPaint();
		/*

	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
	*/
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTestUseEPCSDKDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CTestUseEPCSDKDlg::OnOpen() 
{
	if(m_handle == INVALID_HANDLE_VALUE)
	{
		m_handle = ::OpenComm(3);
		if(m_handle != INVALID_HANDLE_VALUE)
            SetDlgItemText(IDC_OperationList, _T("򿪴ڳɹ\r\n"));
        else
			SetDlgItemText(IDC_OperationList, _T("򿪴ʧܣ\r\n"));
	}
	else
		SetDlgItemText(IDC_OperationList, _T("Ѵ򿪣\r\n"));
}

void CTestUseEPCSDKDlg::OnClose() 
{
	if(m_handle != INVALID_HANDLE_VALUE)
	{
        ::CloseComm(m_handle);
        m_handle = INVALID_HANDLE_VALUE;
        SetDlgItemText(IDC_OperationList, _T("رմڳɹ\r\n"));
	}
    else
		SetDlgItemText(IDC_OperationList, _T("δ򿪣\r\n"));
}

void CTestUseEPCSDKDlg::OnReadFirmVersion() 
{
	int mainVersion = 0;
    int subVersion = 0;
    if(::ReadFirmwareVersion(m_handle, &mainVersion, &subVersion,0))
	{
		CString str;
		str.Format(_T("Firmware version: %d.%d"), mainVersion, subVersion);
		SetDlgItemText(IDC_OperationList, str);
		theApp.DeviceControl();
	}
    else
		SetDlgItemText(IDC_OperationList, _T("ȡFirmware汾ʧܣ\r\n"));
}

void CTestUseEPCSDKDlg::OnStopReadingTag() 
{
	if(::StopReading(m_handle,0))
	{	SetDlgItemText(IDC_OperationList, _T("ͣǩɹ\r\n"));theApp.DeviceControl();}
    else
		SetDlgItemText(IDC_OperationList, _T("ͣǩʧܣ\r\n"));
}

void CTestUseEPCSDKDlg::OnResumeReadingTag() 
{
	if(::ResumeReading(m_handle,0))
	{	SetDlgItemText(IDC_OperationList, _T("λͷɹ\r\n"));theApp.DeviceControl();}
    else
		SetDlgItemText(IDC_OperationList, _T("λͷʧܣ\r\n"));
}

#define	TIMER_ReadSingleTag		1000
#define	TIMER_ReadMultiTags		1001

void CTestUseEPCSDKDlg::OnStartReadingSingleTag() 
{
	SetTimer(TIMER_ReadSingleTag, 500, NULL);
		m_editList.SetWindowText(_T(""));
}

void CTestUseEPCSDKDlg::OnStopReadingSingleTag() 
{
	KillTimer(TIMER_ReadSingleTag);
	SetDlgItemText(IDC_OperationList, _T("ֹͣ\r\n"));
}

void CTestUseEPCSDKDlg::OnStartReadingMultiTags() 
{
	SetTimer(TIMER_ReadMultiTags, 3000, NULL);
		m_editList.SetWindowText(_T(""));
}

void CTestUseEPCSDKDlg::OnStopReadingMultiTags() 
{
	KillTimer(TIMER_ReadMultiTags);
	SetDlgItemText(IDC_OperationList, _T("ֹͣ࿨\r\n"));
}

void CTestUseEPCSDKDlg::OnTimer(UINT nIDEvent) 
{
	if(nIDEvent == TIMER_ReadSingleTag)
	{
		BYTE id[12];    // Tag id length is 12
		BYTE devNo = 0;
		BYTE antennaNo = 0;
		if(IdentifyUploadedSingleTag(m_handle, id, &devNo, &antennaNo))
		{
			// Transfer tag ID to Hex Format
			CString strID=_T("");
			CString strTmp;
			for(int i = 0; i < 12; i++)
			{
				strTmp.Format(_T("%02X "), id[i]);
				strID += strTmp;
			}
			// Device No
			CString strDevNo;
			//strDevNo.Format(_T("%d"), devNo);
			// Antenna No
			CString strAntennaNo;
		//	strAntennaNo.Format(_T("%d"), antennaNo);
			// Display
			CString info;
			m_editList.GetWindowText(info);
			//GetDlgItemText(IDC_OperationList,info);
			info=info+strID + _T("\r\n");
			m_editList.SetWindowText(info);
			//SetDlgItemText(IDC_OperationList, info+strID + _T("\r\n")/*+ _T("    Device No: ") + strDevNo + 
			//	_T("    Antenna No: ") + strAntennaNo*/);
			theApp.DeviceControl();
		}
		else 
			SetDlgItemText(IDC_OperationList, _T("ʶǩʧܣ\r\n"));
	}
	else if(nIDEvent == TIMER_ReadMultiTags)
	{
		BYTE idNum = 0;	// Max tag num is 50
		BYTE ids[12 * 50];	// The id length of each is 12, so 12 * 50 bytes is needed
		BYTE devNos[50];
		BYTE antennaNos[50];
		if(::IdentifyUploadedMultiTags(m_handle, &idNum, ids, devNos, antennaNos))
		{
			// Transfer to Hex Format
			CString str;
			CString strTmp;
			for(int j = 0; j < idNum; j++)
			{
				strTmp.Format(_T("No.%d: "), j);
				str +=strTmp;//(_T("No.") + strTmp + _T(": "));
				for(int i = 0; i < 12; i++)
				{
					strTmp.Format(_T("%02X "), ids[12 * j + i]);
					str += strTmp;
				}
				// Device No
				CString strDevNo;
				strDevNo.Format(_T("%d"), devNos[j]);
			//	str += (_T("    Device No: ") + strDevNo);
				// Antenna No
				CString strAntennaNo;
				strAntennaNo.Format(_T("%d"), antennaNos[j]);
			//	str += (_T("    Antenna No: ") + strAntennaNo);
				// Change Line
				str += _T("\r\n");
				
				
			}
			// Display
				CString info;
			m_editList.GetWindowText(info);
			m_editList.SetWindowText(info+str);
		 
			theApp.DeviceControl();
		}
	}
	else
		CDialog::OnTimer(nIDEvent);
}

void CTestUseEPCSDKDlg::OnClear() 
{
	//SetDlgItemText(IDC_OperationList, "");
}

void CTestUseEPCSDKDlg::OnFastWriteTag() 
{
	BYTE id[4] = {0x00, 0x11, 0x22, 0x33};
	if(::FastWriteTagID(m_handle, 4, id,0)){
		SetDlgItemText(IDC_OperationList, _T("дǩIDɹ\r\n"));
		theApp.DeviceControl();
	}
    else
		SetDlgItemText(IDC_OperationList, _T("дǩIDʧܣ\r\n"));
}

void CTestUseEPCSDKDlg::OnWriteTagSingleWord()
{
	if(::WriteTagSingleWord(m_handle, 0x01, 0x02, 0xFF, 0xFF,0))	// EPCַ02д1(2ֽ)
	{	SetDlgItemText(IDC_OperationList, _T("EPCַ02д1(2ֽ)ݳɹ\r\n"));
		theApp.DeviceControl();
	}
	else
		SetDlgItemText(IDC_OperationList, _T("дǩʧܣ\r\n"));
}

void CTestUseEPCSDKDlg::OnReadTagContent()
{
	BYTE data[2];
	if(::ReadTag(m_handle, 0x01, 0x02, 1, data,0))	// EPCַ02ʼ1(2ֽ)
	{
		CString strData;
		strData.Format(_T("%02X %02X "), data[0], data[1]);
		SetDlgItemText(IDC_OperationList, _T("EPCַ02ʼ1(2ֽ)ݳɹ    ")+strData);
		theApp.DeviceControl();
	}
	else
		SetDlgItemText(IDC_OperationList, _T("ǩʧܣ\r\n"));
}

void CTestUseEPCSDKDlg::OnInitializeTag() 
{
	if(::InitializeTag(m_handle,0))
	{	SetDlgItemText(IDC_OperationList, _T("ʼǩɹ\r\n"));
		theApp.DeviceControl();
	}
	else
		SetDlgItemText(IDC_OperationList, _T("ʼǩʧܣ\r\n"));
}

void CTestUseEPCSDKDlg::OnLockTag() 
{
	if(::LockPassWordTag(m_handle,0x12,0x34,0x56,0x78, 02,0))	// Lock All
	 // lockType => 00: LOCK USER, 01: LOCK TID, 02: LOCK EPC, 03: LOCK ACCESS, 04: LOCK KILL, 05: LOCK ALL, other: DO NOT LOCK
	{	SetDlgItemText(IDC_OperationList, _T("ǩɹ\r\n")); theApp.DeviceControl();}
	else
		SetDlgItemText(IDC_OperationList, _T("ǩʧܣ\r\n"));
}

void CTestUseEPCSDKDlg::OnDestroyTag() 
{
	if(::KillTag(m_handle, 0xFF, 0xFF, 0xFF, 0xFF,0))
		SetDlgItemText(IDC_OperationList, _T("ٱǩɹ\r\n"));
	else
		SetDlgItemText(IDC_OperationList, _T("ٱǩʧܣ\r\n"));
}

void CTestUseEPCSDKDlg::OnGetParams()
{
	BYTE params[2];
	// ȡû־ͷ书ʣӦĵֱַΪ0x640x65
	if(::GetReaderParameters(m_handle, 0x64, 2, params,0))
	{
		CString str;
		str.Format(_T("û־: %d. : %d"), params[0], params[1]);
		SetDlgItemText(IDC_OperationList, str);
		theApp.DeviceControl();
	}
	else
		SetDlgItemText(IDC_OperationList, _T("ȡдʧܣ\r\n"));
}

void CTestUseEPCSDKDlg::OnSetParams()
{
	BYTE params[2] = { 0, 140 };
	// û־ = 0书 = 140ӦĵֱַΪ0x640x65
	if(::SetReaderParameters(m_handle, 0x64, 2, params,0))
	{	SetDlgItemText(IDC_OperationList, _T("öдɹ"));theApp.DeviceControl();}
	else
		SetDlgItemText(IDC_OperationList, _T("öдʧܣ\r\n"));
}
