package cn.com.cnarj.view.frame;

import java.awt.BorderLayout;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.Vector;

import javax.swing.BorderFactory;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JScrollPane;
import javax.swing.JSplitPane;
import javax.swing.JTable;
import javax.swing.JTextArea;
import javax.swing.SwingConstants;
import javax.swing.table.DefaultTableModel;

import cn.com.cnarj.control.MainFrameAction;
import cn.com.cnarj.control.upload.ScoketServer;
import cn.com.cnarj.util.DateUtil;
import cn.com.cnarj.util.JStatusBar;
import cn.com.cnarj.util.Pubfun;


public class MainFrame extends JFrame {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	private static final MainFrame instance = new MainFrame();

	private JMenuBar menuBar;// ˵

	private JMenu menu;// ˵

	private JMenuItem menuItem;// ˵

	private JMenu exitMenu,configMenu,startMenu,aboutMenu;//

	private JSplitPane splitPanel;// ָ

	private JScrollPane bottomPanel;// 

	private JScrollPane topPanel;// 
	
	private JTable table;
	
	private Vector titles;
	
	private JTextArea textArea;
	
	private Vector data = new Vector(),lv_data ;
	
	private DefaultTableModel model;
	
//	private TableAction tableaction = new TableAction();

	private String[] buttonName = { "ͨѶ˿", "ϵͳ" };

	private JButton[] buttons = new JButton[2];

	private MainFrameAction action = new MainFrameAction(this);
	
	Pubfun pubfun = new Pubfun();
//	
//	DownClient downclient = new DownClient();
	
	private JStatusBar statusbar;// ϵͳ״̬
	
	int li_i,li_size;

	private MainFrame() {
		init();
	}
     
	
	
	
	public static MainFrame getInstance() {
		return instance;
	}

	public void init() {
		this.setTitle("(ϰ)RJ45߶ͷλV1.0");
		this.setSize(750, 550);
		this.setJMenuBar(createMenuBar());
//		this.add(createToolBar(), BorderLayout.NORTH);
		this.add(createSplitPanel());
		this.add(getStatusBar(),BorderLayout.SOUTH);// ״̬
		this.setLocationRelativeTo(null);
		this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		this.setResizable(false);
		this.setVisible(true);
	}

	/**
	 * ˵
	 * 
	 * @return
	 */
	public JMenuBar createMenuBar() {
		if (menuBar == null) {
			menuBar = new JMenuBar();
			exitMenu = createMenu(menuBar, "ļ");
			createMenuItem(exitMenu, "˳");
			
			configMenu = createMenu(menuBar, "");
			createMenuItem(configMenu, "ͨѶ˿");
//			configMenu.addSeparator();
//			createMenuItem(configMenu, "ϵͳ");
//			configMenu.addSeparator();
//			createMenuItem(configMenu, "ͬ");
//			configMenu.addSeparator();
			
			startMenu = createMenu(menuBar, "");
			createMenuItem(startMenu, "Ӧ");
			startMenu.addSeparator();
			createMenuItem(startMenu, "");
			
			
			aboutMenu = createMenu(menuBar, "");
			createMenuItem(aboutMenu, "");
			
		}
		
		return menuBar;
	}

	/**
	 * ˵
	 * 
	 * @param bar
	 * @param menuName
	 * @return
	 */
	public JMenu createMenu(JMenuBar bar, String menuName) {
		menu = new JMenu(menuName);
		bar.add(menu);
		return menu;
	}

	/**
	 * ˵
	 * 
	 * @param menu
	 * @param itemName
	 */
	public void createMenuItem(JMenu menu, String itemName) {
		menuItem = new JMenuItem(itemName);
		menu.add(menuItem);
		menuItem.addActionListener(action);
	}


	/**
	 * ָ
	 * 
	 * @return
	 */
	public JSplitPane createSplitPanel() {
		if (splitPanel == null) {
			splitPanel = new JSplitPane();
			splitPanel.setOrientation(JSplitPane.VERTICAL_SPLIT);
			
			splitPanel.setDividerLocation(360);
			
			splitPanel.setOneTouchExpandable(true);
			splitPanel.setTopComponent(createTopPanel());
			splitPanel.setBottomComponent(createBottomPanel());	
		}
		return splitPanel;
	}

	/**
	 * 
	 * 
	 * @return
	 */
	public JScrollPane createBottomPanel() {
		if (bottomPanel == null) {
			textArea = new JTextArea();
//			textArea.setText("asdfasdfasdfasdfasdfasdf");
			bottomPanel = new JScrollPane(textArea);
			bottomPanel.setBorder(BorderFactory.createTitledBorder("ϵͳ־"));
//			textArea.setEditable(false);
			
//			bo)ttomPanel.setLayout(new BorderLayout());
		}
		return bottomPanel;
	}

	/**
	 * 
	 * 
	 * @return
	 */
	public JScrollPane createTopPanel() {
		if (topPanel == null) {
			topPanel = new JScrollPane(createTable());
			topPanel.setBorder(BorderFactory.createTitledBorder("ǩϢ"));
		}
		return topPanel;
	}
	
	/**
	 * 
	 * 
	 * @return
	 */
	@SuppressWarnings("unchecked")
	public JTable createTable() {
		titles = new Vector();

		titles.add("");
		titles.add("ǩ");
		titles.add("ʱ");
		titles.add("");
		if (table == null) {
			model = new DefaultTableModel(data, titles);
			table = new JTable(model);
//			table.addMouseListener(tableaction);
//			table.addMouseListener(tableaction);
//			table.addMouseMotionListener(l);
			// table.setAutoResizeMode(table.AUTO_RESIZE_OFF);
		}
		return table;
	}

	/**
	 * ť÷
	 * 
	 * @param name
	 * @return
	 */
	public JButton createButton(String name) {
		JButton button = new JButton(name);
		button.addActionListener(action);
		return button;
	}
	
	/**
	 * Զͼİť
	 * @param name
	 * @param icons
	 * @return
	 */
	public JButton createButton(String name, String icons) {
		JButton button = new JButton(name, new ImageIcon(icons));
		button.setToolTipText(name);
		button.setRolloverEnabled(true);
		button.setBorderPainted(true);
		button.setHorizontalTextPosition(SwingConstants.CENTER);
		button.setVerticalTextPosition(SwingConstants.BOTTOM);
		button.addActionListener(action);
		return button;
	}
	
	@SuppressWarnings("unchecked")
	public void Adddata(ArrayList array){
		li_size = array.size();
		if (li_size == 0 ){
			System.out.println("ʾпն󴫹");
			return;
		}
		data  = new Vector();
		for(li_i = 0 ; li_i < li_size ; li_i ++){
//			System.out.println(array.get(li_i));
			lv_data = new Vector();
			lv_data.add(String.valueOf((li_i)));
			lv_data.add(array.get(li_i).toString());
//			lv_data.add(pubfun.getdatetime());
			lv_data.add("У");
			data.add(lv_data);
		}
		setModel(data);
	}
	
	
	@SuppressWarnings("unchecked")
	public void Adddata(String tagnum){
		if (tagnum == null ){
			System.out.println("ʾпն󴫹");
			return;
		}
		lv_data = new Vector();
		lv_data.add(String.valueOf((data.size() + 1)));
		lv_data.add(tagnum);
		lv_data.add(pubfun.getdatetime());
		lv_data.add("");
		data.add(lv_data);
		setModel(data);
	}
	
	
//	 ////////////////////״̬///////////////////////
	/**
	 * ״̬
	 * 
	 * @return
	 */
	public JStatusBar getStatusBar() {
		if (statusbar == null) {
			statusbar = new JStatusBar();
		}
		// õǰʱDate
		Date nowTime = new Date();
		// ͨSimpleDateFormatĹ췽һָʱĸʽ
		SimpleDateFormat sd = new SimpleDateFormat("yyyyMMdd a HHʱmm ");
		//  Date ʽΪ/ʱַ
		String s1 = sd.format(nowTime);
		statusbar.addStatusCell(300);
		statusbar.addStatusCell(300);
		statusbar.addStatusCell(250);
		statusbar.setStatus(0, "  ʱ : " + s1);
		// ûΪ½û
		statusbar.setStatus(1, "   Ȩ :ϰܿƼչɷ޹˾");
		return statusbar;
	}

	

	
	public DefaultTableModel setModel(Vector data) {
		model.setDataVector(data, titles);
		return model;
	}

	public void insertText(String as_str){
		int ii_i = instance.textArea.getRows();
//		textArea.insert("Ŀǰ:"+ii_i+"\n", 0);
		instance.textArea.insert(DateUtil.getDateFormat(new Date(), "yyyy-MM-dd HH:mm:ss")+"  "+as_str+"\n", ii_i+1);
		if (ii_i > 100000){
			instance.textArea.setText("");
		}
	}
	
//	public void dataSyn(){
//		getInstance().insertText("ͬʼ...");
//		downclient.downxsinfo();
//		downclient.downkqset();
//		getInstance().insertText("ͬ...");
//	}
	
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		MainFrame.getInstance().insertText("ϴʼ...");
		try {
			new ScoketServer().receiveThreadStartup();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

}
